#!/bin/sh

#Copyright (C) 2006 NTT DATA Corporation
#
#This program is free software; you can redistribute it and/or
#Modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation, version 2.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details

#設定情報読み込み
. ${0%/*}/install.cfg
 
EXEC_PATH=${0%/*}


echo ""
                                                                                
echo "###################################################################"
echo "###                                                             ###"
echo "### Operation Management Software Hinemos Agent                 ###"
echo "###                                        Installer Ver 2.1    ###"
echo "###                                                             ###"
echo "###  2006/9/29                                                  ###"
echo "###  Copyright (C) 2006 NTT DATA Corporation.                   ###"
echo "###################################################################"


EXEC_USER=`/usr/bin/whoami`

# check for incorrect user

if [ $EXEC_USER != "root" ]; then
        echo "";
        echo "ERROR  Set up Hinemos Agent at root user";
        echo "";
        exit 1;
fi



while [ 1 ];
do
  echo "Hinemos Agent's"
  echo "     1) Installation"
  echo "     2) Uninstallation"
  echo "     9) Quit this installer"
  echo ""
  echo -n "===> "
 
  read CHOSEN_NUMBER
  
  case ${CHOSEN_NUMBER} in
      1)      
	  
	  echo ""
	  echo "Setup Hinemos agent."
	  echo ""
	  echo ""

		while [ 1 ];
		  do
                  echo "Installation will be start.  Is it all right? (Y/N)"
		  read ANS
		  case ${ANS} in
		      y|Y)
			  
			  # インストール準備部分
			  
			  if [ ! -d ${HINEMOS_AGENT_HOME} ]; then
			      echo "${HINEMOS_AGENT_HOME}は存在しません。作成します。"
			      echo "mkdir -p ${HINEMOS_AGENT_HOME}" 
			      echo ""
			  fi

			  while [ ! "${IPADDR}" ] ;
			  do
			      echo -n "Please input a manager's IP Address --:"
			      read IPADDR
			  done

			
			  # コピー開始
			  echo "Start copying required files."
			  cp -pr $EXEC_PATH/hinemos_agent /opt
			  cp -p $EXEC_PATH/hinemos_agent.cfg ${HINEMOS_AGENT_HOME}/bin
			  echo "Copying required files was completed."
			  echo ""
		          echo "Installing  JRE"
                          sleep 2
                          echo ""
                          cp ${EXEC_PATH}/jre-1_5_0_09-linux-i586.bin ${HINEMOS_AGENT_HOME}
                          CURRENT_DIR=`pwd`
                          cd ${HINEMOS_AGENT_HOME}
                          ${HINEMOS_AGENT_HOME}/jre-1_5_0_09-linux-i586.bin
                          rm ${HINEMOS_AGENT_HOME}/jre-1_5_0_09-linux-i586.bin
                          cd $CURRENT_DIR


			  # マネージャIPアドレスの反映
			  sed "s/%%manager%%/$IPADDR/" ${HINEMOS_AGENT_HOME}/lib/agent/Agent.properties > ${HINEMOS_AGENT_HOME}/lib/agent/Agent.properties_tmp
			  mv -f ${HINEMOS_AGENT_HOME}/lib/agent/Agent.properties_tmp ${HINEMOS_AGENT_HOME}/lib/agent/Agent.properties


			  # ログ転送エージェントへのマネージャIPアドレスの反映
                          sed "s/%%manager%%/$IPADDR/" ${HINEMOS_AGENT_HOME}/lib/log_agent/Agent.properties > ${HINEMOS_AGENT_HOME}/lib/log_agent/Agent.properties_tmp
                          mv -f ${HINEMOS_AGENT_HOME}/lib/log_agent/Agent.properties_tmp ${HINEMOS_AGENT_HOME}/lib/log_agent/Agent.properties

                          HOST=`hostname`
                          sed "s/%%HOST%%/$HOST/" ${HINEMOS_AGENT_HOME}/lib/log_agent/log4j.properties > ${HINEMOS_AGENT_HOME}/lib/log_agent/log4j.properties_tmp
                          mv -f ${HINEMOS_AGENT_HOME}/lib/log_agent/log4j.properties_tmp  ${HINEMOS_AGENT_HOME}/lib/log_agent/log4j.properties
 
			  #一括制御機能のセットアップ
			  echo "Set up the Package control function."
			  echo ""
			  while [ 1 ] ;
			  do
				  echo "Please input the execution method of Package control function."
				  echo "     1) ssh"
				  echo "     2) rsh"
				  echo ""
				  echo -n "===> "
				  read SHELL

				  case ${SHELL} in
					1)
					  break
					  ;;
					2)
					  echo "rsh" >> /etc/securetty
					  echo "${IPADDR} hinemos" > ~/.rhosts
					  break
					  ;;
					*)
					  echo ""
					  ;;
				  esac
			  done
			  
		          #性能管理機能のセットアップ
			  echo "Set up the Performance management function."
			  echo "Net-SNMPのインストール"
			  rpm -Uvh --force --nosignature $SNMP_RPM
			  
                          TMP=0
                          grep "view    systemview    included   .1.3.6.1"  /etc/snmp/snmpd.conf > /dev/null  && TMP=1
                          if [ ! $TMP ] ;  then
                                 echo "view    systemview    included   .1.3.6.1" >> /etc/snmp/snmpd.conf
                          fi
			  echo "/etc/init.d/snmpd restart"
			  /etc/init.d/snmpd restart
			  echo "/sbin/chkconfig --level 345 snmpd on"
			  /sbin/chkconfig --level 345 snmpd on
			  
          		  #監視監理機能のセットアップ
			  echo "Set up the Condition monitoring function."
			  echo ""
			  TMP=0
			  grep "add for Hinemos Manager" /etc/syslog-ng/syslog-ng.conf > /dev/null 2>&1 && TMP=1
			  if [ "${TMP}" -eq 0 ] ; then
				  echo "install syslog-ng"
				  rpm -Uvh --force $SYSLOG_NG_RPM
				                                   LOCAL_ADDR=`cat /etc/hosts | grep $HOST | gawk '{print $1;}'`
                                  echo "#add for Hinemos Agent" >> /etc/syslog-ng/syslog-ng.conf
                                  echo "filter f_hinemos_log { facility(user);  };" >> /etc/syslog-ng/syslog-ng.conf
                                  echo "source s_netudp { udp(ip($LOCAL_ADDR) port(514)); };" >>/etc/syslog-ng/syslog-ng.conf
                                  echo "log { source(s_netudp); filter(f_hinemos_log); destination(d_hinemos);};" >>/etc/syslog-ng/syslog-ng.conf
				  echo "destination d_hinemos { tcp(\"${IPADDR}\" port(514));};" >> /etc/syslog-ng/syslog-ng.conf
				  echo "log { source(s_local);filter(f_mesg);destination(d_hinemos);};" >> /etc/syslog-ng/syslog-ng.conf
				  /etc/init.d/syslog stop
				  /etc/init.d/syslog-ng start
				  /sbin/chkconfig --level 2345 syslog off
				  /sbin/chkconfig --level 2345 syslog-ng on
			  fi
			  echo ""

		      break
		      ;;

		      n|N)
			  echo "Installation is stopped and return to the menu."
			  echo ""
			  sleep 1
			  break
			  ;;
		      *)
		  esac
		done
                ;;
      2)      
          echo "The Hinemos agent will be uninstalled. Is it all right (Y/N)?"
	  read ANS
	  case ${ANS} in
	      y|Y)
                   TMP=0
                   grep "add for Hinemos Manager" /etc/syslog-ng/syslog-ng.conf > /dev/null 2>&1 && TMP=1
                   if [ !"${TMP}" ] ; then
		    echo "Stopping syslo-ng"
                                  /etc/init.d/syslog-ng stop
                                  /etc/init.d/syslog start
                                  /sbin/chkconfig --level 2345 syslog on
                                  /sbin/chkconfig --level 2345 syslog-ng off
                    fi
                   echo "Stopping Net-SNMP"
                  /etc/init.d/snmpd stop
                  /sbin/chkconfig --level 2345 snmpd off
                  rm -fr ${HINEMOS_AGENT_HOME}

                 TMP=0
                 tail -1 /etc/snmp/snmpd.conf | grep "view    systemview    included   .1.3.6.1 " >> /dev/null && TMP=1
                 if [ ${TMP} ] ; then
                        COUNT=`cat /etc/snmp/snmpd.conf | wc -l`
                        COUNT=`expr ${COUNT} - 1`
                        head -${COUNT} /etc/snmp/snmpd.conf >/etc/snmp/snmpd.conf_hinemos_back
                        mv /etc/snmp/snmpd.conf_hinemos_back /etc/snmp/snmpd.conf
                 fi
		
		grep "rsh" /etc/securetty > /dev/null 2>&1
                TMP=$?
                if [ ${TMP} -eq 0 ] ; then

                        echo "Can you remove \"rsh\" from  /etc/securetty? (Y/N)"
                        read TTY
                        case ${TTY} in
                        y|Y)
                                grep -v rsh /etc/securetty > /etc/securetty.tmp
                                mv /etc/securetty.tmp /etc/securetty
                        ;;
                        *)
                        ;;
                        esac
		fi
		if [ -f /root/.rhosts ] ; then
                        echo "Can you remove /root/.rhosts ?(Y/N)"
                        read RHOSTS
                        case ${RHOSTS} in
                        y|Y)
                                rm /root/.rhosts
                        ;;
                        *)
                        ;;
                        esac
                fi

                  ;;
	      *)
		  ;;
	  esac
	  echo ""
	  ;;
      9)      
	  echo "Hinemos agent installer is finished."
	  exit
	  ;;
	*)
	  echo ""
	  sleep 1
	  ;;
  esac
done
